Index: main/plugin-core/src/org/ametys/core/datasource/ldap/LDAPDataSourceManager.java
===================================================================
--- main/plugin-core/src/org/ametys/core/datasource/ldap/LDAPDataSourceManager.java	(revision 0)
+++ main/plugin-core/src/org/ametys/core/datasource/ldap/LDAPDataSourceManager.java	(revision 0)
@@ -0,0 +1,468 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.core.datasource.ldap;
+
+import java.io.File;
+import java.io.FileInputStream;
+import java.io.FileOutputStream;
+import java.io.InputStream;
+import java.io.OutputStream;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Properties;
+
+import javax.xml.transform.OutputKeys;
+import javax.xml.transform.TransformerFactory;
+import javax.xml.transform.TransformerFactoryConfigurationError;
+import javax.xml.transform.sax.SAXTransformerFactory;
+import javax.xml.transform.sax.TransformerHandler;
+import javax.xml.transform.stream.StreamResult;
+
+import org.apache.avalon.framework.activity.Initializable;
+import org.apache.avalon.framework.component.Component;
+import org.apache.avalon.framework.configuration.Configuration;
+import org.apache.avalon.framework.configuration.DefaultConfigurationBuilder;
+import org.apache.cocoon.ProcessingException;
+import org.apache.cocoon.xml.XMLUtils;
+import org.xml.sax.helpers.AttributesImpl;
+
+import org.ametys.core.util.StringUtils;
+import org.ametys.runtime.config.Config;
+import org.ametys.runtime.config.ConfigManager;
+import org.ametys.runtime.parameter.ParameterHelper.ParameterType;
+import org.ametys.runtime.plugin.component.AbstractLogEnabled;
+
+/**
+ * Avalon component handling the LDAP data sources. It manages the file $AMETYS_HOME/datasources-ldap.xml 
+ */
+public class LDAPDataSourceManager extends AbstractLogEnabled implements Component, Initializable
+{
+    /** Avalon Role */
+    public static final String ROLE = LDAPDataSourceManager.class.getName();
+    
+    /** The path of the datasources-ldap.xml file */
+    private static String _ldapDataSourcesFilePath;
+    
+    /** The representation of the datasources-ldap.xml file */
+    private Map<String, LDAPDataSourceDescriptor> _dataSourcesDescriptions;
+    
+    /**
+     * Set the name of the file that will be read by the manager
+     * @param fileName the name of the file
+     */
+    public static void setFilename(String fileName)
+    {
+        _ldapDataSourcesFilePath = fileName;
+    }
+    
+    @Override
+    public void initialize() throws Exception
+    {
+        _dataSourcesDescriptions = new HashMap<> ();
+        
+        File ldapDataSourceFile = new File(_ldapDataSourcesFilePath);
+        if (!ldapDataSourceFile.exists())
+        {
+            ldapDataSourceFile.getParentFile().mkdirs();
+            ldapDataSourceFile.createNewFile();
+        }
+        
+        if (ldapDataSourceFile.length() != 0)
+        {
+            Configuration configuration;
+            try (InputStream is = new FileInputStream(ldapDataSourceFile))
+            {
+                configuration = new DefaultConfigurationBuilder().build(is);
+            }
+            
+            // Initialize the connection pools
+            for (Configuration datasourceConfiguration : configuration.getChildren("datasource"))
+            {
+                String id = datasourceConfiguration.getAttribute("id");
+                
+                String name = datasourceConfiguration.getChild("name").getValue();
+                String description = datasourceConfiguration.getChild("description").getValue("");
+                String baseURL = datasourceConfiguration.getChild("baseURL").getValue();
+                String useSSL = datasourceConfiguration.getChild("useSSL").getValue("");
+                String baseDN = datasourceConfiguration.getChild("baseDN").getValue("");
+                String aliasDereferencing = datasourceConfiguration.getChild("aliasDereferencing").getValue("");
+                String followReferrals = datasourceConfiguration.getChild("followReferrals").getValue("");
+                String authenticationMethod = datasourceConfiguration.getChild("authenticationMethod").getValue("");
+                String adminDN = datasourceConfiguration.getChild("adminDN").getValue("");
+                String adminPassword = datasourceConfiguration.getChild("adminPassword").getValue("");
+                String privateAsString = datasourceConfiguration.getChild("private").getValue("");
+                
+                boolean isUsingSSL = useSSL.equals("true");
+                boolean isFollowingReferrals = followReferrals.equals("true");
+                boolean isPrivate = privateAsString.equals("true");
+                
+                _dataSourcesDescriptions.put(id, new LDAPDataSourceDescriptor(name, description, baseURL, isUsingSSL, baseDN, aliasDereferencing, isFollowingReferrals, authenticationMethod, adminDN, adminPassword, isPrivate));
+            }
+        }
+    }
+
+    /**
+     * Get the parameters of a LDAP data source (label, driver, url, login, password) 
+     * @param id the id of the wanted data source
+     * @return the data source's parameters values
+     * @throws Exception if an exception occurred when retrieving the ldap data source parameters
+     */
+    public LDAPDataSourceDescriptor getLDAPDataSourceDescription (String id) throws Exception
+    {
+        return _dataSourcesDescriptions.get(id);
+    }
+    
+    /**
+     * Get the existing LDAP data sources as JSON 
+     * @return the LDAP data sources descriptors
+     */
+    public Map<String, LDAPDataSourceDescriptor> getLDAPDataSourcesDescriptions ()
+    {
+        return _dataSourcesDescriptions;
+    }
+    
+    /**
+     * Determines if a data source is in use by a configuration parameter
+     * @param id The id of data source to check
+     * @return true if the data source is in use
+     */
+    public boolean isInUse (String id)
+    {
+        Config config = Config.getInstance();
+        if (config != null)
+        {
+            for (String dataSourceId : ConfigManager.getInstance().getIdsByType(ParameterType.DATASOURCE))
+            {
+                String dataSourceValue = config.getValueAsString(dataSourceId);
+                if (dataSourceValue != null && dataSourceValue.equals(id))
+                {
+                    return true;
+                }
+            }
+        }
+        
+        return false;
+    }
+    
+    /**
+     * Save a single data source
+     * @param parameters The parameters of the data source
+     * @throws Exception if an error occurs during the saving process
+     * @return the id of the created/edited data source 
+     */
+    public String saveLDAPDataSource (Map<String, Object> parameters) throws Exception
+    {
+        String id = (String) parameters.get("id");
+        
+        String name = (String) parameters.get("name");
+        String description = (String) parameters.get("description");
+        String baseURL = (String) parameters.get("baseURL");
+        boolean useSSL = (Boolean) parameters.get("useSSL");
+        String baseDN = (String) parameters.get("baseDN");
+        String aliasDereferencing = (String) parameters.get("aliasDereferencing");
+        boolean followReferrals = (Boolean) parameters.get("followReferrals");
+        String authenticationMethod = (String) parameters.get("authenticationMethod");
+        String adminDN = (String) parameters.get("adminDN");
+        String adminPassword = (String) parameters.get("adminPassword");
+        boolean isPrivate = (Boolean) parameters.get("private");
+        
+        LDAPDataSourceDescriptor ldapDataSourceDescriptor = null;
+        if (!_dataSourcesDescriptions.containsKey(id))
+        {
+            ldapDataSourceDescriptor = new LDAPDataSourceDescriptor(name, description, baseURL, useSSL, baseDN, aliasDereferencing, followReferrals, authenticationMethod, adminDN, adminPassword, isPrivate);
+            id = _addLDAPDataSource(ldapDataSourceDescriptor);
+        }
+        else
+        {
+            if (adminPassword == null)
+            {
+                // Get the recorded password : null password => saved password
+                adminPassword = _dataSourcesDescriptions.get(id).getAdminPassword();
+            }
+            ldapDataSourceDescriptor = new LDAPDataSourceDescriptor(name, description, baseURL, useSSL, baseDN, aliasDereferencing, followReferrals, authenticationMethod, adminDN, adminPassword, isPrivate);
+            _dataSourcesDescriptions.put(id, ldapDataSourceDescriptor);
+        }
+        
+        // Save changes in the file
+        _save();
+        
+        return id;
+    }
+    
+    /**
+     * Delete a data source with its id
+     * @param id The id of the data source to delete
+     * @throws Exception if an error occurs during the saving process 
+     */
+    public void removeLDAPDataSource (String id) throws Exception
+    {
+        _dataSourcesDescriptions.remove(id);
+        _save();
+    }
+    
+    /**
+     * Add a LDAP data source
+     * @param parameters the parameters of the new data source
+     * @return the id of the created data source 
+     */
+    private String _addLDAPDataSource(LDAPDataSourceDescriptor ldapDataSourceDescriptor)
+    {
+        String id = "LDAP-" + StringUtils.generateKey();
+        _dataSourcesDescriptions.put(id, ldapDataSourceDescriptor);
+        
+        return id;
+    }
+    
+    /**
+     * Save the LDAP data sources in the datasources-ldap.xml file
+     * @throws TransformerFactoryConfigurationError if an error occurs while configuring the transformer factory
+     * @throws ProcessingException if an error occurs during the saving process
+     */
+    private void _save() throws TransformerFactoryConfigurationError, ProcessingException
+    {
+        File ldapDataSourcesFile = new File(_ldapDataSourcesFilePath);
+        try
+        {
+            // Create file if it doest not already exist
+            if (!ldapDataSourcesFile.exists())
+            {
+                ldapDataSourcesFile.getParentFile().mkdirs();
+                ldapDataSourcesFile.createNewFile();
+            }
+            
+            // create a transformer for saving sax into a file
+            TransformerHandler th = ((SAXTransformerFactory) TransformerFactory.newInstance()).newTransformerHandler();
+
+            // create the result where to write
+            try (OutputStream os = new FileOutputStream(ldapDataSourcesFile))
+            {
+                StreamResult sResult = new StreamResult(os);
+                th.setResult(sResult);
+    
+                // create the format of result
+                Properties format = new Properties();
+                format.put(OutputKeys.METHOD, "xml");
+                format.put(OutputKeys.INDENT, "yes");
+                format.put(OutputKeys.ENCODING, "UTF-8");
+                th.getTransformer().setOutputProperties(format);
+    
+                // Send SAX events
+                th.startDocument();
+                XMLUtils.startElement(th, "datasources");
+                
+                AttributesImpl idAttr = new AttributesImpl();
+                
+                for (String id : _dataSourcesDescriptions.keySet())
+                {
+                    LDAPDataSourceDescriptor ldapDataSourceDescriptor = _dataSourcesDescriptions.get(id);
+                    
+                    idAttr.addAttribute("", "id", "id", "CDATA", id);
+                    XMLUtils.startElement(th, "datasource", idAttr);
+                    XMLUtils.createElement(th, "name", ldapDataSourceDescriptor.getName());
+                    XMLUtils.createElement(th, "description", ldapDataSourceDescriptor.getDescription());
+                    XMLUtils.createElement(th, "baseURL", ldapDataSourceDescriptor.getBaseURL());
+
+                    String isUsingSSL = ldapDataSourceDescriptor.isUsingSSL() ? "true" : "false";
+                    XMLUtils.createElement(th, "private", isUsingSSL);
+                    
+                    XMLUtils.createElement(th, "baseDN", ldapDataSourceDescriptor.getBaseDN());
+                    XMLUtils.createElement(th, "aliasDereferencing", ldapDataSourceDescriptor.getAliasDereferencing());
+                    
+                    String isFollowingReferrals = ldapDataSourceDescriptor.isFollowingReferrals() ? "true" : "false";
+                    XMLUtils.createElement(th, "private", isFollowingReferrals);
+                    
+                    XMLUtils.createElement(th, "authenticationMethod", ldapDataSourceDescriptor.getAuthenticationMethod());
+                    
+                    String adminDN = ldapDataSourceDescriptor.getAdminDN();
+                    XMLUtils.createElement(th, "adminDN", adminDN != null ? adminDN : "");
+                    
+                    String password = ldapDataSourceDescriptor.getAdminPassword();
+                    XMLUtils.createElement(th, "adminPassword", password != null ? password : "");
+                    
+                    String isPrivate = ldapDataSourceDescriptor.isPrivate() ? "true" : "false";
+                    XMLUtils.createElement(th, "private", isPrivate);
+                    XMLUtils.endElement(th, "datasource");
+                    idAttr.clear();
+                }
+                
+                XMLUtils.endElement(th, "datasources");
+                th.endDocument();
+            }
+        }
+        catch (Exception e)
+        {
+            throw new ProcessingException("Unable to save the ldap data sources values", e);
+        }
+    }
+    
+    /**
+     * Object representation of a LDAP data source
+     */
+    public class LDAPDataSourceDescriptor 
+    {
+        /** The name of the data source */
+        private String _name;
+        /** The optional description of the data source */
+        private String _description;
+        /** URL connection to the ldap server. */
+        private String _baseURL;
+        /** Use ssl for connecting to ldap server. */
+        private boolean _useSSL;
+        /** Base DN to the ldap server. */
+        private String _baseDN;
+        /** Alias dereferencing method */
+        private String _aliasDereferencing;
+        /** Enable following referrals. */
+        private boolean _followReferrals;
+        /** Authentication method used. */
+        private String _authenticationMethod;
+        /** Distinguished name of the admin used for searching. */
+        private String _adminDN;
+        /** Password associated with the admin. */
+        private String _adminPassword;
+        /** Is the data source private ? */
+        private boolean _isPrivate;
+        
+        /**
+         * Constructor for a LDAP data source descriptor
+         * @param name the name of the data source
+         * @param description the description of the data source
+         * @param baseURL the base URL of the data source
+         * @param useSSL is the data source using a secured connection ?
+         * @param baseDN the base domain name of the data source
+         * @param aliasDereferencing the alias dereferencing method used by the data source
+         * @param followReferrals is the data source following referrals ?
+         * @param authenticationMethod the authentication method used by the data source
+         * @param adminDN the administrator domain name of the data source
+         * @param adminPassword the password of the administrator
+         * @param isPrivate is the data source private ?
+         */
+        public LDAPDataSourceDescriptor(String name, String description, String baseURL, boolean useSSL, String baseDN, String aliasDereferencing, boolean followReferrals,
+                String authenticationMethod, String adminDN, String adminPassword, boolean isPrivate)
+        {
+            this._name = name;
+            this._description = description;
+            this._baseURL = baseURL;
+            this._useSSL = useSSL;
+            this._baseDN = baseDN;
+            this._aliasDereferencing = aliasDereferencing;
+            this._followReferrals = followReferrals;
+            this._authenticationMethod = authenticationMethod;
+            this._adminDN = adminDN;
+            this._adminPassword = adminPassword;
+            this._isPrivate = isPrivate;
+        }
+
+        /**
+         * Get the name of the data source
+         * @return the name of the data source
+         */
+        public String getName()
+        {
+            return _name;
+        }
+        
+        /**
+         * Get the description of the data source
+         * @return the description of the data source
+         */
+        public String getDescription()
+        {
+            return _description;
+        }
+        
+        /**
+         * Get the URL of the LDAP server
+         * @return the url of the LDAP server
+         */
+        public String getBaseURL()
+        {
+            return _baseURL;
+        }
+        
+        /***
+         * Is the data source using a secured connection ?
+         * @return true if the data source is using a secured connection
+         */
+        public boolean isUsingSSL()
+        {
+            return _useSSL;
+        }
+        
+        /**
+         * Get the base domain name of the data source
+         * @return the base domain name of the data source
+         */
+        public String getBaseDN()
+        {
+            return _baseDN;
+        }
+        
+        /**
+         * Get the alias dereferencing method used by the data source
+         * @return the alias dereferencing method used by the data source
+         */
+        public String getAliasDereferencing()
+        {
+            return _aliasDereferencing;
+        }
+        
+        /**
+         * Is the data source following referrals ?
+         * @return true if the data source is following referrals
+         */
+        public boolean isFollowingReferrals()
+        {
+            return _followReferrals;
+        }
+        
+        /**
+         * Get the authentication method used by the data source
+         * @return the authentication method used by the data source
+         */
+        public String getAuthenticationMethod()
+        {
+            return _authenticationMethod;
+        }
+        
+        /**
+         * Get the admin domain name
+         * @return the admin domain name
+         */
+        public String getAdminDN()
+        {
+            return _adminDN;
+        }
+        
+        /**
+         * Get the admin password
+         * @return the admin password
+         */
+        public String getAdminPassword()
+        {
+            return _adminPassword;
+        }
+        
+        /**
+         * Is the data source private ?
+         * @return true if the data source is private
+         */
+        public boolean isPrivate()
+        {
+            return _isPrivate;
+        }
+    }
+}
